/*
 * MCU16Bit.c
 *
 * Created: 2015-10-02 9:32:05 AM
 *  Author: max
 */

//For the ATMEGA2561
#define F_CPU 16000000

#define MCU16BIT

#include "CFAF240320D-032T.h"

int main(void)
{
	DDRA = 0xFF;	// low data port, all outputs
	DDRB = 0xFF;	// UNUSED
	DDRC = 0xFF;	// Command lines
	DDRD = 0x0F;	// VPP and led pins output
	DDRE = 0xFF;	// high data port, all outputs
	DDRF = 0xFF;	// Interface select - all outputs
	
	PORTA = 0x00;	// initial values
	PORTB = 0x20;	// UNUSED
	PORTC = 0x00;	// Pin 0 BL pin/ off by default
	PORTD = 0xF8;	// pull-up on switches, all others off
	PORTE = 0x00;	// initial values

	//Does the display work?
	BL_ON
	setInterface();
	displayInit();
	writeColorBars(320, 240);
	delay(100);
	
	// Bring up the uSD card
	MMC_SD_Init();    //SPI initialize

	// Show the pictures from the uSD card on the display
	pictureSlideShow();
	
	while(1);
}
